--[[
The Icarus Project, Copyright (c) 2005 John Forsythe <chaosmachine@gmail.com> (aka chaosmachine)
Feel free to learn and borrow from this code for non-commercial purposes.
If you use my code in your project, I'd appreciate a credit in your readme file.
]]

function checkPad()
	pad = Controls.read()
	if oldPad ~= pad then sleep = 0 end
	oldPad = pad
	
	if pad:start() then
		p.start = (p.start or 0) + 1
		if p.start == 30 then
			startLevel(level, true, true)
		end
	else
		p.start = 0
	end
	
	if pad:up() then
		sleep = 0
		p.up = (p.up or 0) + 1
		moveCursor(0,-1, p.up)
	else
		p.up = 0
	end
 
	if pad:down() then
		p.down = (p.down or 0) + 1
		moveCursor(0,1, p.down)
	else
		p.down = 0
	end
 
	if pad:left() then
		p.left = (p.left or 0) + 1
		moveCursor(-1,0, p.left)
	else
		p.left = 0
	end
	
	if pad:right() then
		p.right = (p.right or 0) + 1
		moveCursor(1,0, p.right)
	else
		p.right = 0
	end 
	
	if pad:square() then
		p.square = (p.square or 0) + 1
		if p.square == 1 then
			if moveMode == true then
				dropPiece()
			else
				grabPiece()
			end
		end
	else
		p.square = 0
	end
	
	if pad:cross() then
		p.cross = (p.cross or 0) + 1
		if p.cross == 1 and moveMode == true then
			modifyPiece("flipY")
		end
	else
		p.cross = 0
	end
	
	if pad:triangle() then
		p.triangle = (p.triangle or 0) + 1
		if p.triangle == 1 and moveMode == true then
			modifyPiece("rotate")
		end
	else
		p.triangle = 0
	end
	
	if pad:circle() then
		p.circle = (p.circle or 0) + 1
		if p.circle == 1 and moveMode == true then
			modifyPiece("flipX")
		end
	else
		p.circle = 0
	end
	
	if pad:select() then
		p.select = (p.select or 0) + 1
	else
		if (p.select or 0) > 0 then -- button released
			showMenu()
		end
		p.select = 0
	end	
	
	-- various debugging controls follow
	
-- 	if pad:r() then
-- 		sleep = 0
-- 		p.r = (p.r or 0) + 1
-- 		if p.r == 1 then nextSong() end
-- 	else
-- 		p.r = 0
-- 	end
	
-- 	if pad:l() then
-- 		sleep = 0
-- 		p.l = (p.l or 0) + 1
-- 		-- colorswap
--  		c = checkCursorForPiece()
-- 		if p.l == 1 and c ~= 0 then
-- 			piece[c].style = math.mod(piece[c].style+1, 5)
-- 			for i,aBlock in ipairs(piece[c]) do
-- 				aBlock.tile = getTile(aBlock.bType, piece[c].style)
-- 			end
-- 			updateBlockImage()
-- 			doUpdateScreen = 1
-- 		end
-- 	else
-- 		p.l = 0
-- 	end
	
-- 	if pad:l() and pad:triangle() then
-- 		local t = os.date("%Y_%m_%d_%H_%M_%S", os.time())
-- 		timestamp = t
-- 		System.usbDiskModeDeactivate()
-- 		screen.waitVblankStart()
-- 		screen:save("out/screenshot."..timestamp..".png")
-- 		screen.waitVblankStart()
-- 		System.usbDiskModeActivate()
-- 		wrongMove()
-- 	end
	
-- 	if pad:l() and pad:circle() then
-- 		dumpPieces()
-- 	end
-- 	
-- 	if pad:l() and pad:square() then
-- 		load()
-- 	end
-- 	
-- 	if pad:l() and pad:cross() then
-- 		save()
-- 	end
	
-- 	if pad:l() and pad:right() then
-- 		level=math.mod(level, levels)+1
-- 		startLevel(level, true)
-- 	end

end

function moveCursor(dx, dy, count)
	allowMove = false
	
	-- supersecret cursor acceleration tech! :ninja:
	if count == 1 then
		allowMove = true
	end
	
	if count > 8 and math.mod(count, 4) == 0 then
		allowMove = true
	end
	
	if count > 17 and math.mod(count, 3) == 0 then
		allowMove = true
	end
	
	if count > 26 and math.mod(count, 2) == 0 then
		allowMove = true
	end
	
	if count > 35 then
		allowMove = true
	end
	
	if allowMove == true then
		-- save cursor position
		cursor.lastX = cursor.x
		cursor.lastY = cursor.y
		
		-- update cursor position
		cursor.x = cursor.x + dx
		cursor.y = cursor.y + dy
		
		-- keep the cursor in bounds
		if cursor.x > 29 - xOffset or cursor.x < 0 then
			cursor.x = cursor.lastX
		end
		
		if cursor.y > 15 - yOffset or cursor.y < 1 then
			cursor.y = cursor.lastY
		end	
		

		if moveMode == true then
			-- save piece position
			piece[grabbed].lastX = piece[grabbed].x
			piece[grabbed].lastY = piece[grabbed].y
		
			-- update piece position
			piece[grabbed].x = piece[grabbed].x + dx
			piece[grabbed].y = piece[grabbed].y + dy
			
			-- keep the block in bounds
			if checkPieceInBounds() == false then
				piece[grabbed].x = piece[grabbed].lastX
				cursor.x = cursor.lastX
				piece[grabbed].y = piece[grabbed].lastY
				cursor.y = cursor.lastY
			end
		end
		doUpdateScreen = 1
	end
end

function grabPiece()
	if grabbed ~= 0 and grabbed == true then return end
	grabbed = checkCursorForPiece()
	if grabbed == 0 then return end
	moveMode = true
	updateBlockImage()
	doUpdateScreen = 1
end

function dropPiece()
	if checkForOverlap() == 0 and checkForBorder() == 0 then
		moveMode = false
		local g = checkForGoal()
		piece[grabbed].inGoal = g
		grabbed = 0
		if g == 1 then checkForWin() end
	else
		wrongMove()
	end
	updateBlockImage()
	doUpdateScreen = 1
end

function modifyPiece(action)
	for i,aBlock in ipairs(piece[grabbed]) do
		-- backup piece incase we land out of bounds
		aBlock.oldX = aBlock.x
		aBlock.oldY = aBlock.y
		-- perform action
		if action == "flipX" then aBlock.x = (-2 * aBlock.x +6) + aBlock.x end
		if action == "flipY" then aBlock.y = (-2 * aBlock.y +6) + aBlock.y end
		if action == "rotate" then
			aBlock.y = (-2 * aBlock.y +6) + aBlock.y
			aBlock.y, aBlock.x = aBlock.x, aBlock.y
		end
	end
	if checkPieceInBounds() == false then
		-- we're out of bounds, revert to last position
		for ii,aBlock in ipairs(piece[grabbed]) do
			aBlock.x = aBlock.oldX
			aBlock.y = aBlock.oldY
		end
		wrongMove()
	else
		-- reposition cursor if we lost it in the move
		if checkCursorForPiece() ~= grabbed then
			cursor.x = piece[grabbed].x + piece[grabbed][3].x
			cursor.y = piece[grabbed].y + piece[grabbed][3].y 
		end
	end
	-- recalculate the block types
	getPieceBlockTypes(piece[grabbed])
	updateBlockImage()
	doUpdateScreen = 1
end

function checkPieceInBounds()
	for i,aBlock in ipairs(piece[grabbed]) do
		local x = piece[grabbed].x + aBlock.x
		local y = piece[grabbed].y + aBlock.y
		if x < 0 or x > 29 - xOffset then return false end
		if y < 1 or y > 15 - yOffset then return false end
	end
	return true
end

function checkCursorForPiece()
	for i,aPiece in ipairs(piece) do
		for ii,aBlock in ipairs(aPiece) do
			if (cursor.x == aPiece.x + aBlock.x) and (cursor.y == aPiece.y + aBlock.y) then
				return i
			end
		end
	end
	return 0
end

function checkForOverlap()
	for i,aPiece in ipairs(piece) do
		for ii,aBlock in ipairs(aPiece) do
			for iii,bBlock in ipairs(piece[grabbed]) do
				if (piece[grabbed].x + bBlock.x == aPiece.x + aBlock.x)
				and (piece[grabbed].y + bBlock.y == aPiece.y + aBlock.y)
				and (grabbed ~= i) then
					return i
				end
			end
		end
	end
	return 0
end

function checkForBorder()
	for i,aBorder in ipairs(border) do
		for ii,bBlock in ipairs(piece[grabbed]) do
			if (piece[grabbed].x + bBlock.x == border.x + aBorder.x)
			and (piece[grabbed].y + bBlock.y == border.y + aBorder.y) then
				return i
			end
		end
	end
	return 0
end

function checkForGoal()
	for i,aBlock in ipairs(piece[grabbed]) do
		for ii,aGoal in ipairs(goal) do
			if (piece[grabbed].x + aBlock.x == border.x + aGoal.x)
			and (piece[grabbed].y + aBlock.y == border.y + aGoal.y) then
				return 1
			end
		end
	end
	return 0
end

function checkForWin()
	weWin = true
	for i,aPiece in ipairs(piece) do
		if aPiece.inGoal ~= 1 then
			weWin = false -- if a piece isn't in goal yet, we haven't won
			return
		end
	end	
 	if weWin == true then winLevel() end
end

function winLevel()
	winTime = levelSeconds()
	screen.waitVblankStart(10)	
	-- victory dance
	for ii,aPiece in ipairs(piece) do
		aPiece.style = 0
	end
	
	screen.flip()
	--screen:blit(0, 0, win, 0, 0, win:width(), win:height(), false)
	
	screen.waitVblankStart()
	screen.flip()
	while not Controls.read():start() do
		for ii,aPiece in ipairs(piece) do
			aPiece.style = math.mod(aPiece.style+1, 5)
			for iii,aBlock in ipairs(aPiece) do
				aBlock.tile = getTile(aBlock.bType, aPiece.style)
			end
		end
		screen:blit(0, 0, background, 0, 0, 480, 272, false)
		screen:blit(0,0,fader)
		updateBlockImage()
		screen:blit(0, 0, blockImage)
		screen:print(24, 261, "You did it! Time: "..secondsToTime(winTime)..". Press start to continue...", colorWhite)
		screen.waitVblankStart(3)
		screen.flip()
	end
	-- prebuffer screen for fadeout
	updateScreen(1)
	updateScreen(1)
	fadeOut()
	if level == levels then winGame() end
	level = math.mod(level, levels) +1
	startLevel(level)
end

function winGame()
	if Music.playing() then Music.stop() end
	Music.playFile("mus/6.xm", true)
	Music.volume(128)
	
	win = Image.createEmpty(480, 272)
	win:print(1,0,"Congratulations!", colorRed)
	win:print(1,12,"You beat the final level!", colorWhite)
	win:print(1,36,"Thanks for playing The Icarus Project!", colorBlue)
	win:print(1,60,"Credits", colorRed)
	win:print(1,72," Programming: John Forsythe", colorWhite)
	win:print(1,84," Artwork: John Forsythe", colorWhite)
	win:print(1,96," Level Design: John Forsythe", colorWhite)
	win:print(1,108," Sound Effects: John Forsythe", colorWhite)
	win:print(1,120," Audio Conversion: John Forsythe", colorWhite)
	win:print(1,132," Music: Vivaldi, Corelli, Bach, James", colorWhite)
	win:print(1,144," Beta Testing: Jen, Andy, Debra, Angus, Sophie", colorWhite)
	win:print(1,156," Photography: Debra Forsythe", colorWhite)
	win:print(1,168," Original Concept: Vik Tokai", colorWhite)
	
	-- unroll credits
	for i=40,218 do
		screen:fillRect(0,0,480,272, colorBlack)
		screen:blit(40,40,win)
		screen:fillRect(0,i,480,272, colorBlack)
		if math.mod(i-3,12) == 0 then
			screen.waitVblankStart(60)
		else
			screen.waitVblankStart(3)
		end
		screen.flip()
	end
	
	screen.waitVblankStart(120)
	
	-- scroll credits
	for i=40,-178,-1 do
		screen:fillRect(0,0,480,272, colorBlack)
		screen:blit(40,i,win)
		screen.waitVblankStart(2)
		screen.flip()
	end
	
	screen:print(70,131,"Don't forget to visit www.chaosmachine.net!", colorBlue)
	screen.waitVblankStart()
	screen.flip()
	screen.waitVblankStart(500)
	
	local i=0
	local c=179
	while not Controls.read():start() do
		c=c+1
		if c==180 then
			c=0
			i=math.mod(i+1, levels-1)
			background = Image.load("bkg/bkg"..(i+2)..".png")
		end
		screen:blit(0,0,background)
		outlineText(214,131,"The End", colorWhite, colorBlack)
		screen.waitVblankStart()
		screen.flip()
	end
end